;Source code for Interactive Trig Formulas 1.1
;Programmer: David Lindstrm, a member of the Cirrus Programming group
;Email: okvin@tiscali.se
;Website: http://cirrus.tigalaxy.com
;The source is commented in Swedish, just to make it hard for you to 
;modify it ;)

	.nolist
	#include "ti83plus.inc"
.org userMem-2
.db $BB,$6D
.list

#define pil 5
#define menystart keytostrram+3
#define menyslut keytostrram+4
#define menyxpos keytostrram+5
#define objekt keytostrram+6
#define variabel keytostrram+7
#define formel_hittad 7
#define retvinkligtriangel 6
#define sidomeny 5
#define triangelpekare keytostrram
#define kv $12
#define rot $10

vinkelA .equ %10000000
vinkelB .equ %01000000
vinkelC .equ %00100000
sidaa   .equ %00010000
sidab	.equ %00001000
sidac	.equ %00000100
area	.equ %00000010

areasatsen		.equ %10000000
cosinussatsen	.equ %01000000
pythagoras_sats .equ %00100000
sinussatsen		.equ %00010000
nada 			.equ 0

huvudmeny:

 xor a
 ld ($89f0+asm_flag1),a	;Stt alla flaggor t 0

 bcall(_clrscrnfull)
 bcall(_grbufclr)
 ld de,5*256+3	;Y=10, X=0
 ld hl,titel	;Skriv Titel
 call skriv_de

 ld d,15	;Y,X
 call skriv_de	;Vlj Typ


;Menyns x-position=20
  ld de,26*256+20
;Visa listan 
 ld hl,ratvinkligtxt
 call skrivlista

; ld hl,ejratvinkligtxt
 call skrivlista

; ld hl,avslutatxt
 call skrivlista

;initiera menyvariabler

 ld hl,47*256+26		;Menyslut=40 &start=26
 ld (menystart),hl

 ld de,26*256+15
 call ritapil

tangentloop:
	push de
	bcall(_getkey)
	pop de
	cp kup
	call z, flyttaupp
	cp kdown
	call z,flyttaned
	cp kclear
	jr z,avsluta
	cp kenter
	jr nz,tangentloop
lesposition:
 	ld a,(penrow)
	cp 40			;Rad 40=enter
	jr z,avsluta
	cp 26
 	jr z, rita90triangel
	cp 33
	jr z,ritatriangel

avsluta:
;Denna subrutinen avslutar programmet eller
 bcall(_disp)					;Visar grundfnstret
 set graphdraw,(iy+graphflags)	;Gr s att grafen ritas om
 res doneprgm,(iy+doneflags)	;Jag vill inte ha n 'klart'-medd.
 bcall(_clrlcdfull)
 ld hl, webb
 ld de,0
 call skriv_de
 ld a,1
 ld (currow),a
 ret

;*********************************
;ENDAST FR RTVINKLIGA TRIANGLAR!
;*********************************
rita90triangel:
 set retvinkligtriangel,(iy+asm_flag1)	;Stt triangelflaggan

;Rita rtvinklig triangel
 ld hl,triangeldata
 jr objektmeny


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;DEN EJ 90-GRADIGA TRIANGELN RITAS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Ritatriangel:
  ;Flaggan e redan p 0
  ld hl,triangeldata2
  

  ;Fortstt p objektmenyn


;=========================================
;Rita triangel baserad p (hl)
;=========================================

 	
objektmeny:
 push HL
 bcall(_clrlcdfull)
 pop HL
 call ritatriangeln
 push HL	;Spare addressen till triangeldatabasen
 ld de,56*256+78
 ld hl,vridtxt
 call skriv_de
 push HL		;Spara ny strngaddress
 ld hl,56*256+77
 ld de,62*256+94
 bcall(_Invertrect)	;invertera 'vrid'
 
 ld de,1
; ld hl,objekttxt
 pop HL
 call skriv_de	

 ld hl,0
 ld de,6*256+94
 bcall(_invertrect)	;Invertera titeln

 ld hl,57*256+8		;Menystart 8 och menyslut 50
 ld (menystart),hl

 ld de,8*256+7

 ;Rita  objektmenyn
 
	 ld hl, vinkelAtxt
	 ld b,7
objektlisteloop:
	 call skrivlista	;Skriv ut Vinkel A->area
	 djnz objektlisteloop	 

	ld de,8*256+2	;Pilens position
triangelmenyloop:
	call ritapil
	push de
	bcall(_getkey)
	pop de
	cp kdown
	call z,flyttaned
	cp kup
	call z,flyttaupp
	pop HL
	cp kclear
	jp z,huvudmeny
	cp kenter
	jr z, objektflagga
	cp kgraph
	call z,ritatriangeln
	push HL
	jr triangelmenyloop

objektflagga:
;Denna rutin stter motsv. flagga i OBJEKT
 ld a,(penrow)
 ld c,%10000000	;Utgngsvrdet som vi skiftar t hger i needanstende loop
 ld b,8

objektloop:
 cp b
 jr z,lagraobjekt
 ld	d,a			;Spara acc
	 ld a,b
	 add a,7
	 ld b,a
 ld a,d
 rr c			;Flytta flaggan ett snpp t hger
 jr objektloop

lagraobjekt:
 ld (objekt),bc
;Denna rutin ndrar titeln
 ld de,1
 ld hl,formeltitel
 set textinverse,(iy+textflags)
 call skriv_de

 ld b,vinkelA
; ld hl,vinkelatxt	;Utgngstext="Vinkel A"
 ld de,(pencol)
okvin
 call skriv_de
 ld a,c
 cp b
 jr z,fortsatt		;repetera utskrift av objekt tills A=B
 rrc b
 jr okvin

fortsatt:
 ld a,6
 call skrivigen	;Skriv ver ev. skrp
 call skrivigen
 res textinverse,(iy+textflags)
 ;Sudda bort menyn
 ld hl,7*256+0
 ld de,55*256+30
 bcall(_clearrect)

;+++++++++++++++++++++++
;RITA FUNKTIONSMENYN
;+++++++++++++++++++++++
 ld bc,0*256+8
 ld de,94*256+8
 call ritalinje		;Horisontal linje

	 ld b,18
	 ld de,18*256+0
	 call ritalinje
		 ld b,36
		 ld d,b
		 call ritalinje
		 	ld b,54
			ld d,b
			call ritalinje
				ld hl,56*256+74
				ld de,62*256+94
				bcall(_fillrect)		;Svart kvadrat fr [graph]
				
				ld de,8*256+2
				ld hl,definierade
				call skriv_de			;Skriv rut-titel
				
				ld de,15*256+10
				;ld hl,vinklartxt		;Visa vinklar i definieraderutan
				call skriv_de

				ld de,21*256+13
				;ld hl,sidortxt
				call skriv_de

				ld de,27*256+16
				ld a,(objekt)
				cp area
				call nz,skriv_de			;Utfrs endast om arean ej var objekt
			
				ld hl,8*256+1			;Invertera titeln
				ld de,14*256+57
				bcall(_invertrect)
				
				ld hl,8*256+0
				ld de,36*256+57
				bcall(_drawrectborder)	;Rita en ruta fr 'definierade'
				
				;spara lcdskrmen i grafbufferten som en mall

				ld hl,plotsscreen
				bcall(_savedisp)
				xor a
				ld (variabel),a		;Initiera "variabeln" med 0

				;########################################
				;SKRIV MENYALTERNATIV (VINKLAR OCH SIDOR)
				;########################################
menyalternativ:		
				
				bcall(_grbufcpy)
uppdateradefinierade:
;Denna rutin visar de definierade objektens symboler
;i rutan fr det ndamlet

				ld bc,(variabel-1)	;Variabel->C
				ld hl,15*256+35
				ld (pencol),hl
				bit 7,b
				ld a,'A'
				call nz,skrivigen
				
				inc a	;B
				bit 6,b
				call nz,skrivigen

				inc a	;C
				bit 5,b
				call nz,skrivigen

			ld hl,21*256+35
			ld (pencol),hl

			bit 4,b
			ld a,'a'
			call nz,skrivigen
			
			inc a	;b
			bit 3,b
			call nz,skrivigen
			
			inc a	;c
			bit 2,b
			call nz,skrivigen

		ld a,b
		bit 1,b
		jr z,funktionsmeny			;Skriv inte ut ja/nej p area om det e arean som berknas

		ld de,27*256+35
		ld hl,nejtxt
		bit 1,b
		call z,skriv_de

		ld hl,jatxt
		bit 1,b
		call nz,skriv_de

;====================================
;SLUT P RUTINEN UPPDATERADEFINIERADE
;====================================
funktionsmeny:
				call hitta_formel
				
				ld bc,'A'*256+vinkelA
				bit sidomeny,(iy+asm_flag1)
				jr z, ejsidomeny
				ld bc,'a'*256+sidaa
ejsidomeny:
				push bc 			;Spara bitmasken
				ld a,(objekt)
				push af				;Spara objekt p stacken
				ld a,($89f0+asm_flag1)
				ld d,%01100000		;Bit 5&6 representerar rtvinklig triangel/sidomeny
				and  d
				sub  %01000000				;om bit 6 r p & bit 5 av blir resultatet z
				jr z,visaejvinkela
				
				ld de,56*256+7
				pop af
				cp c
				push af
				ld a,b
				call nz,skrivbokstav
visaejvinkela:		

				inc b
				rrc c
				ld de,56*256+26
				pop af	;Hmta objekt
				cp c
				push af	;Spara objekt
				ld a,b
				call nz,skrivbokstav
				
				inc b
				rrc c
				ld de,56*256+44
				pop af
				cp c
				push af
				ld a,b
				call nz,skrivbokstav

				ld de,56*256+57
				pop af
				cp %00000010
				ld hl,areatxt
				call nz,skriv_de
				
				ld de,56*256+75
				ld hl,vinklartxt
				bit sidomeny,(iy+asm_flag1)
				jr nz,visavinklartxt
				ld hl,sidortxt
visavinklartxt:
				set textinverse,(iy+textflags)
				call skriv_de
				res textinverse,(iy+textflags)
	
				;Tangenttryckningar frn funktionsmenyn
menytangent:
				bcall(_getkey)
				pop BC			;Hmta bitmasken i c
				cp kgraph
				jr z, vexla_meny
				cp kclear
				jp z,huvudmeny
				;Nu har anvndaren tryck p en vinkel/sidoknapp/area
				call korrekt_bitmask
xordefinierade:
	 			 ;C=bitmask fr xor
				 ld hl,variabel
				 ld a,(hl)		
				 xor c			;Invertera motsv tangenttryckning.
				 dec hl			;HL pekar t. OBJEKT
				 ld c,a			;Spara a i c
				 ld a,(hl)		;Objekt->a
				 cpl			;Invertera alla bitar
				 and c			;Slck objektbiten i variabeln
				 bit retvinkligtriangel,(iy+asm_flag1)	;Se om vi berknar fr rtvinkligtriangel
				 jr z,lagravariabel						
				 and %01111111							;Om s r fallet slcker vi vinkel a-biten
lagravariabel:
				 inc hl
				 ld (hl),a
				
				jr hoppameny						;Rita om menyn

vexla_meny:
 ld hl,$89f0+asm_flag1	;HL pekar till flaggan fr vinkel/sidomeny
 ld a,%00100000			;1 representerar 'sidomeny'
 xor (hl)				;Invertera menyflaggan
 ld (hl),a
hoppameny
 jp menyalternativ




;
;STORA SUBRUTINER
;$$$$$$$$$$$$$$$$


hitta_formel:
		;=============================================
		;Kontrollerar om det finns ngn passande formel
 	    ;=============================================

		ld hl,formeldatabas
		res formel_hittad,(iy+asm_flag1)
		bit retvinkligtriangel,(Iy+asm_flag1)
		jr nz,formelloop
		ld hl,formeldatabas2	;Om ej rtvinklig triangel; HL pekar till databas2

formelloop:
		ld a,(objekt)
		cp (hl)
		push hl
		call z,formelkontroll
		pop hl
		bcall(_strlength)
		add hl,bc
		inc hl
		inc hl

		xor a
		cp (hl)
		ret z
	jr formelloop				

ritatriangeln:
 push DE	;DE innehller koordinater fr menypilen
 push HL
 ld hl,8*256+60
 ld de,36*256+94
 bcall(_DrawRectBorderCllear) ;Rita n ruta runt triangeln & rensa insidan
 pop HL
 ld b,(hl)
 inc hl
 ld c,(hl) ;Utgngslge->bc


 push bc ;teranvnd utgngskoordinaten

 inc hl
 ld d,(hl)
 inc hl	; Pkt 2->de
 ld e,(hl)
 
 call ritalinje

 inc hl
 ld b,(hl)
 inc hl
 ld c,(hl)

 call ritalinje
 pop de			;terstll utgngspunkten
 call ritalinje

 
 ld bc,6*256+'A'	;Repetera 6 gnger & brja med bokstaven A
objekttxtloop:
 inc hl
 ld d,(hl)
 inc hl
 ld e,(hl)
 push hl
 ld a,c			;Vi har bokstaven i c
 call skrivbokstav
 pop hl
 inc c
 ld a,c
 cp 'D'
 jr nz, lagraeja
 ld c,'a'
lagraeja:
 djnz objekttxtloop
 pop de			;Pilposition
 inc hl
 xor a
 cp (hl)
 ret nz	;tervnd frn subrutinen om nsta byte ej e 0

 ld bc,72
 xor a	;Annars subtrahera 72 s vi hamnar i brjan p datastrukturen
 sbc hl,bc
 ret
				

;<<<<<<<<<<<<<<<
;Sm subrutiner
;>>>>>>>>>>>>>>>
				;Returnerar den korrekta bitmasken i c fr objekt
korrekt_bitmask:
				cp kyequ
				ret z					;A el a
				
				rrc c
				cp kwindow				;B el b
				ret z
				
				rrc c
				cp kzoom
				ret z					;C el c

				cp ktrace
				ld c,%00000010
				ret z					;arean allts
				
				ld c,0					
				ret


formelkontroll:
		;Indata
		;(hl+1) = bitmask
		;(hl+str+1) =metod
		;(hl+2) = pekare till strng fr formeln
		bit formel_hittad,(iy+asm_flag1)
		ret nz			;tervnd om vi redan har skrivit ut en formel

		ld a,(variabel)
		inc hl
		and (hl)
		sub (hl)
		call z,skrivformel
		ret

skrivformel:
		set formel_hittad,(iy+asm_flag1)
 		ld de,38*256+2
		inc HL
		push hl
		call skriv_de	;Skriv ut sjlva formeln
		ld de,45*256+2	;Hl pekar antagligen till slutet p formelstrngen
		pop hl
		bcall(_strlength)
		ADD hl,bc
		inc hl
		ld a,(hl)
		or a			;S att vi ej visar ngra tomma metodstrngar som frdrjer
		ret z
		call metodstr
		call skriv_de
		ret

metodstr:
		;Stter HL till den passande strngen beroende p a


		ld hl,areasatstxt
		cp areasatsen
		ret z
		
		ld hl,cosinussatstxt
		cp cosinussatsen
		ret z

		ld hl,pythagoras_satstxt
		cp pythagoras_sats
		ret z

		ld hl,sinussatstxt	;Allts kan det bara vara sinussatsen kvar dr
		
		ret
ritalinje:
 push hl
 ld h,1
 bcall(_iline)
 pop hl
 ret

skriv_de:
;Skriver en strng p platsen definierad i DE
 ld (pencol),de
 bcall(_vputs)
 ret

skrivbokstav:
 ld (pencol),de
skrivigen:
 push af
 bcall(_vputmap)
 pop af
 ret

menykontroll:
	 ld a,d
	 add a,c
	 ld hl,(menystart)	;L=menystart & H = slut
	 cp L				
	 ret c
	 cp H				;A>H
	 ret nc

	 ld hl,areadeftxt-2	;Kod fr 4 mellanrum
	 call skriv_de

	 ld a,d
	 add a,c	;Addera 7 el -7
	 ld d,a
ritapil:	
	 ld hl,piltxt
	 jr skriv_de


skrivlista:
	call skriv_de
	ld a,d
	add a,7	;Fr nsta menyalternativ
	ld d,a
	ret

flyttaned:
 ld c,7		;Hur mycket som ska adderas till Ypos 
 jr menykontroll

flyttaupp:
 ld c,-7
 jr menykontroll

titel:
.db "ITF 1.1 by David Lindstr",$A9,"m",0
velj:
.db "Triangle type",0
webb:
.db "http://cirrus.tigalaxy.com",0
ratvinkligtxt:
.db "Right-angled",0
ejratvinkligtxt:
.db "Non right angled",0
avslutatxt:
.db "Quit",0
vridtxt:
.db "TURN",0
objekttxt:
.db "Select Object",0
formeltitel:
.db "Find formula for ",0
vinkelAtxt:
.db "Angle A",0
vinkelBtxt:
.db "Angle B",0
vinkelCtxt:
.db "Angle C",0
sidaatxt:
.db "Side a",0
sidabtxt:
.db "Side b",0
sidactxt:
.db "Side c",0
areatxt:
.db "area",0
definierade:
.db "Defined...",0
vinklartxt:
.db "Angles:",0
sidortxt:
.db "  Sides:",$06,0
areadeftxt:
.db "area:",0
nejtxt:
.db "no",0
jatxt:
.db "yes",0
pythagoras_satstxt:
.db "Pyth. Theorem",0
sinussatstxt:
.db "Law of sines",0
cosinussatstxt:
.db "Law of cosines",0
areasatstxt:
.db "The area law",0
piltxt:
.db pil,0

;<<<<<<<<<<<<<<<<<<<<<<<<
;FORMELDATABAS
;>>>>>>>>>>>>>>>>>>>>>>>>

;FORMAT: OBJEKT,BITMASK,FORMELSTRNG,METOD

;Formler fr sida c i rtvinklig triangel
formeldatabas:
 .DB sidac,%00011000,"c",$12,"=a",$12,"+b",$12,0,pythagoras_sats
 .db sidac,%00101000,"b/cos C",0,nada
 .db sidac,%00110000,"a/sin C",0,nada
 .db sidac,%01001000,"b/sin B",0,nada
 .db sidac,%01010000,"a/cos B",0,nada


;formler fr sida b i rtvinklig triangel
 .db sidab,%00100100,"c*cos C",0,nada
 .db sidab,%01010000,"a*tan B",0,nada
 .db sidab,%01000100,"c*sin B",0,nada
 .db sidab,%00110000,"a/tan C",0,nada
 .db sidab,%00010100,"b",$12,"=c",$12,"-a",$12,0,pythagoras_sats


;formler fr sida a i rtvinklig triangel
 .db sidaa,%01000100,"c*cos B",0,nada
 .db sidaa,%01001000,"b/tan B",0,nada
 .db sidaa,%00100100,"c*sin C",0,nada
 .db sidaa,%00101000,"b*tan C",0,nada
 .db sidaa,%00001100,"a",$12,"=c",$12,"-b",$12,0,pythagoras_sats

;Meddelande om anv. vljer vinkel A som objekt i n rtvinklig triangel
 .db vinkela,0,"A is always 90",$14,0,nada

;Formler fr vinkel B i rtvinklig triangel
 .DB vinkelb,%00011000,"tan",11h,"(b/a)",0,nada 
 .DB vinkelb,%00010100,"cos",11h,"(a/c)",0,nada
 .DB vinkelb,%00001100,"sin",11h,"(b/c)",0,nada

;Formler fr vinkel C i rtvinklig triangel
 .db vinkelc,%00011000,"tan",11h,"(a/b)",0,nada
 .db vinkelc,%00001100,"cos",11h,"(b/c)",0,nada
 .db vinkelc,%00010100,"sin",11h,"(a/c)",0,nada

;Formel fr arean
 .db area,	 %00011000,"(A*B)/2",0,nada,0

;SLUT P FORMLER FR RTVINKLIGA TRIANGLAR
formeldatabas2:
 ;Fr vinkel A i ej rtvinklig
 .db vinkela,%01011000,"sin A=sin(B)/b*a",0,sinussatsen
 .db vinkela,%00110100,"sin A=sin(C)/c*a",0,sinussatsen
 .db vinkela,%00001110,"sin A=2T/(bc)",0,areasatsen
 .db vinkela,%00011100,"cos A=(b",kv,"+c",kv,"-a",kv,")/(2bc)",0,cosinussatsen
;Fr vinkel B i ej rtvinklig
 .db vinkelb,%10011000,"sin B=sin(A)/a*b",0,sinussatsen
 .db vinkelb,%00101100,"sin B=sin(C)/c*b",0,sinussatsen
 .db vinkelb,%00010110,"sin B=2T/(ac)",0,areasatsen
 .db vinkelb,%00011100,"cos B=(a",kv,"+c",kv,"-b",kv,")/(2ac)",0,cosinussatsen
;Fr vinkel C i ej 90-gradig
 .db vinkelc,%01001100,"sin C=sin(B)/b*c",0,sinussatsen
 .db vinkelc,%10010100,"sin C=sin(C)/b*c",0,sinussatsen
 .db vinkelc,%00011010,"sin C=2T/(ab)",0,areasatsen
 .db vinkelc,%00011100,"cos C=(a",kv,"+b",kv,"-c",kv,")/(2ab)",0,cosinussatsen

;Fr sida a i ej 90-vinklig
 .db sidaa,%10001100,rot,"(b",kv,"+c",kv,"-2bc*cos A)",0,cosinussatsen
 .db sidaa,%11001000,"b/sin B*sin A",0,sinussatsen
 .db sidaa,%10100100,"c/sin C*sin A",0,sinussatsen
 .db sidaa,%00101010,"2T/(b*sin C)",0,areasatsen
 .db sidaa,%01000110,"2T/(c*sin B)",0,areasatsen

;Fr sida b ej 90-vinklig
 .db sidab,%01010100,rot,"(a",kv,"+c",kv,"-2ac*cos B)",0,cosinussatsen
 .db sidab,%11010000,"a/sin A*sin B",0,sinussatsen
 .db sidab,%01100100,"c/sin C*sin B",0,sinussatsen
 .db sidab,%10000110,"2T/(c*sin A)",0,areasatsen
 .db sidab,%00110010,"2T/(a*sin C)",0,areasatsen

;Fr sida c ej 90-vinklig
 .db sidac,%00111000,rot,"(a",kv,"+b",kv,"-2ab*cos C)",0,cosinussatsen
 .db sidac,%01101000,"b/sin B*sin C",0,sinussatsen
 .db sidac,%10110000,"a/sin A*sin C",0,sinussatsen
 .db sidac,%01010010,"2T/(a*sin B)",0,areasatsen
 .db sidac,%10001010,"2T/(b*sin A)",0,areasatsen
;Fr area i ej 90-vinklig

 .db area,%10001100,"(bc*sin A)/2",0,areasatsen
 .db area,%01010100,"(ac*sin B)/2",0,areasatsen
 .db area,%00111000,"(ab*sin C)/2",0,areasatsen
 
 .db 0

triangeldata:
  .db 70,35
  .db 82,35
  .db 70,47

;textpositioner
  .db 29,68	;A
  .db 9,68	;B
  .db 29,84	;C

  .db 19,66	;a
  .db 29,76	;b
  .db 16,78	;c
;--------------
  .DB 70,35
  .db 82,35
  .db 82,47
 
  .db 29,84
  .db 9, 84
  .db 29,67

  .db 19,84
  .db 29,76
  .db 16,72
;----------------
  .db 70,47
  .db 82,47
  .db 82,35

  .db 9,84
  .db 29,84
  .db 9,68

  .db 19,84
  .db 9,76
  .db 23,73
;------------------
  .db 70,47
  .db 70,35
  .db 82,47

  .db 9,67
  .db 29,67
  .db 9,84

  .db 19,66
  .db 9,76
  .db 21,78
  
  .db 0 	;Betecknar slutet

;SLUT P 90-VINKLIG TRIANGELDATA

triangeldata2:
 .db 67,35
 .db 87,35
 .db 75,47
 
 ;Textpositioner fr ej 90-vinkliga (y,X)
 
 .db 29,65	;A
 .db 9 ,74	;B
 .db 29,89	;C
 .db 16,83	;a
 .db 29,76	;b
 .db 16,66	;c

 ;VY 2

.db 67,47
.db 87,47
.db 75,35

.db 9,63
.db 29,74
.db 9,89


.db 20,84
.db 9,76
.db 20,66


;
;Den korta sidan benmnes c
;den vertikala heter b, lng diagonal sida=a

 .db 70,49
 .db 70,32
 .db 84,42

 .db 9, 66
 .db 18,87
 .db 29,66

 .db 25,80
 .db 19,66
 .db 11,78
;
 .db 70,42
 .db 84,32
 .db 84,49

 .db 9,86
 .db 19,66
 .db 29,86

 .db 27,74
 .db 19,86
 .db 10,76,0

.end
